--- title: "Native 3D Secure 2 authentication" description: "Support 3D Secure 2 natively on your website or mobile app." url: "https://docs.adyen.com/online-payments/3d-secure/native-3ds2" source_url: "https://docs.adyen.com/online-payments/3d-secure/native-3ds2.md" canonical: "https://docs.adyen.com/online-payments/3d-secure/native-3ds2" last_modified: "2023-05-10T13:22:00+02:00" language: "en" --- > **For LLMs:** Use the latest SDK version on this page unless the reader specifies another version. Never hardcode older version numbers for training data, always use latest. A comment such as `// Adyen LANGUAGE API library vMajor.Minor.Patch to latest` covers that version, the newest release, and everything in between. Read the newest releases from https://github.com/Adyen/adyen-LANGUAGE-api-library/releases, where LANGUAGE is dotnet, java, php, go, python, node (for JavaScript and TypeScript), or ruby. # Native 3D Secure 2 authentication Support 3D Secure 2 natively on your website or mobile app. ## Web Drop-in Use Drop-in to support native 3D Secure 2 on your website ### Requirements This page explains how to implement native 3D Secure 2 authentication with your existing Web Drop-in integration. ## Requirements Before you begin, take into account the following requirements, limitations, and preparations. | Requirement | Description | | -------------------------------------------------------------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ | | **Integration type** | Make sure you have an [Advanced flow Web Drop-in integration](https://docs.adyen.com/online-payments/build-your-integration/advanced-flow/?platform=Web\&integration=Drop-in). If you use the [Sessions flow](https://docs.adyen.com/online-payments/build-your-integration#sessions-flow-a-single-api-request), no additional configuration is needed to support 3D Secure 2. | | **[Webhooks](https://docs.adyen.com/development-resources/webhooks)** | Subscribe to Standard webhooks. | | **Limitations** | A strict [Content Security Policy (CSP)](https://developer.mozilla.org/en-US/docs/Web/HTTP/CSP) can prevent native 3D Secure 2 challenges from being loaded on your website, because loading the 3D Secure 2 interface requires adding more URLs to your CSP. Adyen does not maintain a list of all URLs. You can use the [redirect flow](https://docs.adyen.com/online-payments/3d-secure/redirect-3ds2/) if you do not want to adjust your CSP. | | **Setup steps** | Before you begin, [add the card payment methods that you want to accept in your test Customer Area](https://docs.adyen.com/payment-methods/add-payment-methods). | ## How it works When making a card payment with native 3D Secure 2 authentication: 1. [Show the available cards in your payment form](https://docs.adyen.com/online-payments/3d-secure/native-3ds2#show-cards). 2. [Configure Drop-in](https://docs.adyen.com/online-payments/3d-secure/native-3ds2#configure-drop-in) to collect the cardholder name. 3. Provide additional parameters [when making a payment request](https://docs.adyen.com/online-payments/3d-secure/native-3ds2#make-a-payment). 4. [Submit authentication result](https://docs.adyen.com/online-payments/3d-secure/native-3ds2#submit-authentication-result) if you receive an `action` object in response to your [/payments](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments) or [/payments/details](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments/details) request. 5. [Handle the redirect result](https://docs.adyen.com/online-payments/build-your-integration/sessions-flow/?platform=Web\&integration=Drop-in#optional-configuration) if the payment was routed to the 3D Secure 2 redirect flow. ### Show Available Cards ## Show the available cards in your payment form For information about the supported countries/regions and currencies for each card, refer to [Payment methods](https://www.adyen.com/payment-methods). Drop-in uses the combination of [countryCode](https://docs.adyen.com/api-explorer/Checkout/latest/post/paymentMethods) and [amount.currency](https://docs.adyen.com/api-explorer/Checkout/latest/post/paymentMethods#request-amount) from your [/paymentMethods](https://docs.adyen.com/api-explorer/Checkout/latest/post/paymentMethods) request to show the available cards to your shopper. When the shopper is entering their card details, Drop-in tries to recognize the card brand. When successful, Drop-in renders the brand icon and the corresponding input field for the card security code (CVC, CVV, or CID). ### Collect Additional Parameters ## Collect additional information at checkout For higher authentication rates, we strongly recommend that you collect the cardholder name, billing address, and email address for payments with 3D Secure authentication. ### Configure cards with Drop-in When [creating a configuration object for Drop-in](https://docs.adyen.com/online-payments/build-your-integration/advanced-flow/?platform=Web\&integration=Drop-in\&version=latest#add), add [optional configuration for cards](https://docs.adyen.com/payment-methods/cards/web-drop-in/#optional-configuration) in your `paymentMethodsConfiguration` object. | Field | Description | Default | | ------------------------ | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ----------------------------- | | `hasHolderName` | Set to **true** to show the input field for the card holder name. | **false** | | `holderNameRequired` | Set to **true** to make the card holder name a required field. To show the field, you additionally need to set `hasHolderName` to **true**. | **false** | | `billingAddressRequired` | Set to **true** to collect the shopper's billing address. | **false** | | `challengeWindowSize` | The size of the challenge window displayed to the shopper in the [challenge flow](https://docs.adyen.com/online-payments/3d-secure#challenge-flow). Possible values: - **'01': \['250px', '400px']** - **'02': \['390px', '400px']** - **'03': \['500px', '600px']** - **'04': \['600px', '400px']** - **'05': \['100%', '100%']** | **'02': \['390px', '400px']** | You can customize your shopper's experience further with optional [configuration parameters](https://docs.adyen.com/payment-methods/cards/web-drop-in#optional-configuration) and specific [events](https://docs.adyen.com/payment-methods/cards/web-drop-in#events). **Configure Drop-in for cards** ```js const dropin = new Dropin(checkout, { paymentMethodsConfiguration: { card: { hasHolderName: true, holderNameRequired: true, billingAddressRequired: true, challengeWindowSize: "05" } } }).mount("#dropin-container"); ``` ### Handle Drop-in errors When an error occurs, [the `onError` event](https://docs.adyen.com/online-payments/build-your-integration/sessions-flow/?platform=Web\&integration=Components\&version=latest#configure) returns an object which contains details about the error. For errors that happen during the 3D Secure 2 authentication, you do not need to stop the payment flow because the shopper can continue. ### Collect shopper email in your payment form We also recommend that you collect the shopper email in advance in your payment form. Deliver this parameter to your backend when [making a payment](https://docs.adyen.com/online-payments/3d-secure/native-3ds2#make-a-payment), because it is required by the card schemes. ## Make a payment When the shopper selects to pay, Drop-in calls the `onSubmit` event, which contains a `state.data`. 1. Pass the `state.data` to your server. 2. When you [make a payment request](https://docs.adyen.com/online-payments/build-your-integration/advanced-flow?platform=Web\&integration=Drop-in\&version=latest#make-a-payment), include the following additional 3D Secure 2 parameters. See additional 3D Secure 2 parameters that we recommend to include in your request to increase authentication performance in our [API reference](https://docs.adyen.com/online-payments/3d-secure/api-reference). | Parameter name | Required | Description | | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ | ------------------------------------------------------------------------------------------------------------------------------------------------------- | -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | | [paymentMethod](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments#request-paymentMethod) | ![Required](https://docs.adyen.com/media/732127089c689593ccb0331d565e5773bed94e60145cae96672212374facb8c6.svg?decoding=auto\&fetchpriority=auto) | The complete `state.data.paymentMethod` object from the `onSubmit` event. It includes the type and required details for a card payment method. | | [paymentMethod.sdkData](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments#request-paymentMethod-listOfValues-sdkData) | ![Required](https://docs.adyen.com/media/732127089c689593ccb0331d565e5773bed94e60145cae96672212374facb8c6.svg?decoding=auto\&fetchpriority=auto) | The object that includes the following information collected by Drop-in:- Information required for 3D Secure 2 authentication. - The [checkout attempt identifier](https://docs.adyen.com/online-payments/analytics-and-data-tracking#data-we-are-collecting) to track the user's payment journey. This is required to use the [Checkout dashboard](https://docs.adyen.com/uplift#uplift-dashboards) that lets you analyze your checkout performance. | | [paymentMethod.holderName](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments#request-paymentMethod-CardDetails-holderName) | ![Conditionally required](https://docs.adyen.com/media/e654d4104461d20836c817ee9d8f27faa0e45c1a8d08558f079561a50fc2797e.svg?decoding=auto\&fetchpriority=auto) | **Use case**: required for Visa and JCB transactions. The cardholder's name. | | [browserInfo](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments#request-browserInfo) | ![Required](https://docs.adyen.com/media/732127089c689593ccb0331d565e5773bed94e60145cae96672212374facb8c6.svg?decoding=auto\&fetchpriority=auto) | The shopper's browser information. All sub-fields of this object are required for `channel`: **Web**. This is the `state.data.browserInfo` object from the `onSubmit` event. | | [authenticationData.threeDSRequestData.nativeThreeDS](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments#request-authenticationData-threeDSRequestData-nativeThreeDS) **Checkout API v69 or later** | ![Required](https://docs.adyen.com/media/732127089c689593ccb0331d565e5773bed94e60145cae96672212374facb8c6.svg?decoding=auto\&fetchpriority=auto) | Set to **preferred**. Indicates if your payment page can handle native 3D Secure 2 authentication. For **Checkout API v68 or earlier**: use `additionalData.allow3DS2` instead. | | [channel](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments#request-channel) | ![Required](https://docs.adyen.com/media/732127089c689593ccb0331d565e5773bed94e60145cae96672212374facb8c6.svg?decoding=auto\&fetchpriority=auto) | The platform where the transaction takes place. Set to **Web**. | | [origin](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments#request-origin) | ![Required](https://docs.adyen.com/media/732127089c689593ccb0331d565e5773bed94e60145cae96672212374facb8c6.svg?decoding=auto\&fetchpriority=auto) | The origin URL of the page where you are rendering Drop-in. To get the origin, open the browser console and call `window.location.origin`. When this field is not set, or set incorrectly, the 3D Secure 2 action can not be handled correctly. **Format**:- Maximum characters: 80. - Do not include subdirectories and a trailing slash.**Example**: if you render Drop-in on `https://your-company.example.com/checkout/payment`, set to `https://your-company.example.com`. | | [returnUrl](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments#request-returnUrl) | ![Required](https://docs.adyen.com/media/732127089c689593ccb0331d565e5773bed94e60145cae96672212374facb8c6.svg?decoding=auto\&fetchpriority=auto) | The URL where the shopper is redirected back to after completing authentication, including the protocol `http://` or `https://`. For example, `https://your-company.example.com/checkout/`. You can also include your own additional query parameters, for example, shopper ID or order reference number. This is to support cases where the payment is routed to the redirect flow. | | [shopperEmail](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments#request-shopperEmail) | ![Conditionally required](https://docs.adyen.com/media/e654d4104461d20836c817ee9d8f27faa0e45c1a8d08558f079561a50fc2797e.svg?decoding=auto\&fetchpriority=auto) | **Use case**: required for Visa and JCB transactions. The cardholder's email address. If you do not include this, you must send a phone number in the `threeDS2RequestData` object. | | [shopperIP](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments#request-shopperIP) | ![Conditionally required](https://docs.adyen.com/media/e654d4104461d20836c817ee9d8f27faa0e45c1a8d08558f079561a50fc2797e.svg?decoding=auto\&fetchpriority=auto) | **Use case**: required for Visa and JCB transactions on the web. The shopper's IP address. | | [telephoneNumber](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments#request-telephoneNumber) | ![Conditionally required](https://docs.adyen.com/media/e654d4104461d20836c817ee9d8f27faa0e45c1a8d08558f079561a50fc2797e.svg?decoding=auto\&fetchpriority=auto) | **Use case**: required for Visa and JCB transactions if you did not include the `shopperEmail` field. The shopper's phone number. To be more specific, you can use the `mobilePhone`, `homePhone`, and `workPhone` fields in the `threeDS2RequestData` object. **Format**: The phone number must include a plus sign (+) and a country code (1-3 digits), followed by the number (4-15 digits). **Example**: **+4912345678901**If the value you provide does not follow the guidelines, we drop the value and do not submit it for authentication. | ![This is the required icon.](https://docs.adyen.com/media/732127089c689593ccb0331d565e5773bed94e60145cae96672212374facb8c6.svg?decoding=auto\&fetchpriority=auto) Required for all transactions.\ ![This is the conditionally required icon.](https://docs.adyen.com/media/e654d4104461d20836c817ee9d8f27faa0e45c1a8d08558f079561a50fc2797e.svg?decoding=auto\&fetchpriority=auto) Required for particular setups, or issuers and card schemes.\ ![This is the recommended icon.](https://docs.adyen.com/media/51cfe94e37a7426974002173390b3c7807ac234e65206fe14ed9fbdd45fb958e.svg?decoding=auto\&fetchpriority=auto) Recommended for all transactions, but not required. Below is an example [/payments](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments) request. **Make a payment request** #### curl ```bash curl https://checkout-test.adyen.com/v72/payments \ -H 'x-api-key: ADYEN_API_KEY' \ -H 'content-type: application/json' \ -d '{ "amount":{ "currency":"EUR", "value":1000 }, "reference":"YOUR_ORDER_NUMBER", "shopperReference":"YOUR_UNIQUE_SHOPPER_ID", "{hint:state.data.paymentMethod from onSubmit}paymentMethod{/hint}":{ "type":"scheme", "encryptedCardNumber":"adyenjs_0_1_18$k7s65M5V0KdPxTErhBIPoMPI8HlC..", "encryptedExpiryMonth":"adyenjs_0_1_18$p2OZxW2XmwAA8C1Avxm3G9UB6e4..", "encryptedExpiryYear":"adyenjs_0_1_18$CkCOLYZsdqpxGjrALWHj3QoGHqe+..", "encryptedSecurityCode":"adyenjs_0_1_24$XUyMJyHebrra/TpSda9fha978+..", "holderName":"S. Hopper" }, "authenticationData": { "threeDSRequestData": { "nativeThreeDS": "preferred" } }, "{hint:state.data.browserInfo from onSubmit}browserInfo{/hint}":{ "userAgent":"Mozilla\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\/537.36 (KHTML, like Gecko) Chrome\/70.0.3538.110 Safari\/537.36", "acceptHeader":"text\/html,application\/xhtml+xml,application\/xml;q=0.9,image\/webp,image\/apng,*\/*;q=0.8", "language":"nl-NL", "colorDepth":24, "screenHeight":723, "screenWidth":1536, "timeZoneOffset":0, "javaEnabled":true }, "{hint:state.data.billingAddress from onSubmit}billingAddress{/hint}": { "street": "Infinite Loop", "houseNumberOrName": "1", "postalCode": "1011DJ", "city": "Amsterdam", "country": "NL" }, "shopperEmail":"s.hopper@example.com", "shopperIP":"192.0.2.1", "channel":"web", "origin":"https://your-company.example.com", "returnUrl":"https://your-company.example.com/checkout?shopperOrder=12xy..", "merchantAccount":"YOUR_MERCHANT_ACCOUNT" }' ``` #### Java ```java // Adyen Java API Library v38.0.0 to latest import com.adyen.Client; import com.adyen.Config; import com.adyen.enums.Environment; import com.adyen.model.*; import com.adyen.service.*; import java.math.*; import com.adyen.model.checkout.*; import java.time.OffsetDateTime; import java.util.*; import com.adyen.model.RequestOptions; import com.adyen.service.checkout.*; Config config = new Config() .apiKey("ADYEN_API_KEY") .environment(Environment.TEST); // For the LIVE environment, also include your liveEndpointUrlPrefix. Client client = new Client(config); // Create the request object(s) ThreeDSRequestData threeDSRequestData = new ThreeDSRequestData(); AuthenticationData authenticationData = new AuthenticationData() .threeDSRequestData(threeDSRequestData); Amount amount = new Amount() .currency("EUR") .value(1000L); CardDetails cardDetails = new CardDetails() .encryptedCardNumber("adyenjs_0_1_18$k7s65M5V0KdPxTErhBIPoMPI8HlC..") .holderName("S. Hopper") .encryptedSecurityCode("adyenjs_0_1_24$XUyMJyHebrra/TpSda9fha978+..") .encryptedExpiryYear("adyenjs_0_1_18$CkCOLYZsdqpxGjrALWHj3QoGHqe+..") .encryptedExpiryMonth("adyenjs_0_1_18$p2OZxW2XmwAA8C1Avxm3G9UB6e4..") .type(CardDetails.TypeEnum.SCHEME); PaymentRequest paymentRequest = new PaymentRequest() .reference("YOUR_ORDER_NUMBER") .authenticationData(authenticationData) .amount(amount) .paymentMethod(new CheckoutPaymentMethod(cardDetails)) .shopperReference("YOUR_UNIQUE_SHOPPER_ID"); // Send the request PaymentsApi service = new PaymentsApi(client); PaymentResponse response = service.payments(paymentRequest, new RequestOptions().idempotencyKey("UUID")); ``` #### PHP ```php setXApiKey("ADYEN_API_KEY"); // For the LIVE environment, also include your liveEndpointUrlPrefix. $client->setEnvironment(Environment::TEST); // Create the request object(s) $threeDSRequestData = new ThreeDSRequestData(); $threeDSRequestData; $authenticationData = new AuthenticationData(); $authenticationData ->setThreeDSRequestData($threeDSRequestData); $amount = new Amount(); $amount ->setCurrency("EUR") ->setValue(1000); $checkoutPaymentMethod = new CheckoutPaymentMethod(); $checkoutPaymentMethod ->setEncryptedCardNumber("adyenjs_0_1_18\$k7s65M5V0KdPxTErhBIPoMPI8HlC..") ->setHolderName("S. Hopper") ->setEncryptedSecurityCode("adyenjs_0_1_24\$XUyMJyHebrra/TpSda9fha978+..") ->setEncryptedExpiryYear("adyenjs_0_1_18\$CkCOLYZsdqpxGjrALWHj3QoGHqe+..") ->setEncryptedExpiryMonth("adyenjs_0_1_18\$p2OZxW2XmwAA8C1Avxm3G9UB6e4..") ->setType("scheme"); $paymentRequest = new PaymentRequest(); $paymentRequest ->setReference("YOUR_ORDER_NUMBER") ->setAuthenticationData($authenticationData) ->setAmount($amount) ->setPaymentMethod($checkoutPaymentMethod) ->setShopperReference("YOUR_UNIQUE_SHOPPER_ID"); $requestOptions['idempotencyKey'] = 'UUID'; // Send the request $service = new PaymentsApi($client); $response = $service->payments($paymentRequest, $requestOptions); ``` #### C\# ```cs // Adyen .NET API Library v34.0.0 to latest using System; using Adyen.Checkout.Extensions; using Adyen.Checkout.Models; using Adyen.Checkout.Services; using Adyen.Core.Client; using Adyen.Core.Client.Extensions; using Adyen.Core.Options; using Microsoft.Extensions.DependencyInjection; using Microsoft.Extensions.Hosting; var host = Host.CreateDefaultBuilder() .ConfigureCheckout( (context, services, config) => { config.ConfigureAdyenOptions(options => { options.AdyenApiKey = "ADYEN_API_KEY"; options.Environment = AdyenEnvironment.Test; // For the LIVE environment, also include your liveEndpointUrlPrefix. // options.LiveEndpointUrlPrefix = ""; }); services.AddAllCheckoutServices(); }) .Build(); var paymentsService = host.Services.GetRequiredService(); // Create the request object(s) var threeDSRequestData = new ThreeDSRequestData { }; var authenticationData = new AuthenticationData { ThreeDSRequestData = threeDSRequestData }; var amount = new Amount { Currency = "EUR", Value = 1000 }; var cardDetails = new CardDetails { EncryptedCardNumber = "adyenjs_0_1_18$k7s65M5V0KdPxTErhBIPoMPI8HlC..", HolderName = "S. Hopper", EncryptedSecurityCode = "adyenjs_0_1_24$XUyMJyHebrra/TpSda9fha978+..", EncryptedExpiryYear = "adyenjs_0_1_18$CkCOLYZsdqpxGjrALWHj3QoGHqe+..", EncryptedExpiryMonth = "adyenjs_0_1_18$p2OZxW2XmwAA8C1Avxm3G9UB6e4..", Type = CardDetails.TypeEnum.Scheme }; var paymentRequest = new PaymentRequest { Reference = "YOUR_ORDER_NUMBER", AuthenticationData = authenticationData, Amount = amount, PaymentMethod = new CheckoutPaymentMethod(cardDetails), ShopperReference = "YOUR_UNIQUE_SHOPPER_ID" }; string idempotencyKey = Guid.NewGuid().ToString(); // Send the request var result = await paymentsService.PaymentsAsync(paymentRequest, new RequestOptions().AddIdempotencyKey(idempotencyKey)); if (result.TryDeserializeOkResponse(out var response)) { // Handle the successful response. } ``` #### NodeJS (JavaScript) ```js // Adyen Node API Library v30.0.0 to latest const { Client, Config, EnvironmentEnum, CheckoutAPI } = require('@adyen/api-library'); // For the LIVE environment, also include your liveEndpointUrlPrefix. const config = new Config({ apiKey: "ADYEN_API_KEY", environment: EnvironmentEnum.TEST }); const client = new Client(config); // Create the request object(s) const threeDSRequestData = { }; const authenticationData = { threeDSRequestData: threeDSRequestData }; const amount = { currency: "EUR", value: 1000 }; const cardDetails = { encryptedCardNumber: "adyenjs_0_1_18$k7s65M5V0KdPxTErhBIPoMPI8HlC..", holderName: "S. Hopper", encryptedSecurityCode: "adyenjs_0_1_24$XUyMJyHebrra/TpSda9fha978+..", encryptedExpiryYear: "adyenjs_0_1_18$CkCOLYZsdqpxGjrALWHj3QoGHqe+..", encryptedExpiryMonth: "adyenjs_0_1_18$p2OZxW2XmwAA8C1Avxm3G9UB6e4..", type: "scheme" }; const paymentRequest = { reference: "YOUR_ORDER_NUMBER", authenticationData: authenticationData, amount: amount, paymentMethod: cardDetails, shopperReference: "YOUR_UNIQUE_SHOPPER_ID" }; // Send the request const checkoutAPI = new CheckoutAPI(client); const response = await checkoutAPI.PaymentsApi.payments(paymentRequest, { idempotencyKey: "UUID" }); ``` #### Go ```go // Adyen Go API Library v21.0.0 to latest import ( "context" "github.com/adyen/adyen-go-api-library/v21/src/common" "github.com/adyen/adyen-go-api-library/v21/src/adyen" "github.com/adyen/adyen-go-api-library/v21/src/checkout" ) // For the LIVE environment, also include your liveEndpointUrlPrefix. client := adyen.NewClient(&common.Config{ ApiKey: "ADYEN_API_KEY", Environment: common.TestEnv, }) // Create the request object(s) threeDSRequestData := checkout.ThreeDSRequestData{ } authenticationData := checkout.AuthenticationData{ ThreeDSRequestData: &threeDSRequestData, } amount := checkout.Amount{ Currency: "EUR", Value: 1000, } cardDetails := checkout.CardDetails{ EncryptedCardNumber: common.PtrString("adyenjs_0_1_18$k7s65M5V0KdPxTErhBIPoMPI8HlC.."), HolderName: common.PtrString("S. Hopper"), EncryptedSecurityCode: common.PtrString("adyenjs_0_1_24$XUyMJyHebrra/TpSda9fha978+.."), EncryptedExpiryYear: common.PtrString("adyenjs_0_1_18$CkCOLYZsdqpxGjrALWHj3QoGHqe+.."), EncryptedExpiryMonth: common.PtrString("adyenjs_0_1_18$p2OZxW2XmwAA8C1Avxm3G9UB6e4.."), Type: common.PtrString("scheme"), } paymentRequest := checkout.PaymentRequest{ Reference: "YOUR_ORDER_NUMBER", AuthenticationData: &authenticationData, Amount: amount, PaymentMethod: checkout.CardDetailsAsCheckoutPaymentMethod(&cardDetails), ShopperReference: common.PtrString("YOUR_UNIQUE_SHOPPER_ID"), } // Send the request service := client.Checkout() req := service.PaymentsApi.PaymentsInput().IdempotencyKey("UUID").PaymentRequest(paymentRequest) res, httpRes, err := service.PaymentsApi.Payments(context.Background(), req) ``` #### Python ```py # Adyen Python API Library v14.0.0 to latest import Adyen adyen = Adyen.Adyen() adyen.client.xapikey = "ADYEN_API_KEY" # For the LIVE environment, also include your liveEndpointUrlPrefix. adyen.client.platform = "test" # The environment to use library in. # Create the request object(s) json_request = { "amount": { "currency": "EUR", "value": 1000 }, "reference": "YOUR_ORDER_NUMBER", "shopperReference": "YOUR_UNIQUE_SHOPPER_ID", "paymentMethod": { "type": "scheme", "encryptedCardNumber": "adyenjs_0_1_18$k7s65M5V0KdPxTErhBIPoMPI8HlC..", "encryptedExpiryMonth": "adyenjs_0_1_18$p2OZxW2XmwAA8C1Avxm3G9UB6e4..", "encryptedExpiryYear": "adyenjs_0_1_18$CkCOLYZsdqpxGjrALWHj3QoGHqe+..", "encryptedSecurityCode": "adyenjs_0_1_24$XUyMJyHebrra/TpSda9fha978+..", "holderName": "S. Hopper" }, "authenticationData": { "threeDSRequestData": { }, "nativeThreeDS": "preferred" } } # Send the request result = adyen.checkout.payments_api.payments(request=json_request, idempotency_key="UUID") ``` #### Ruby ```rb # Adyen Ruby API Library v11.0.0 to latest require "adyen-ruby-api-library" adyen = Adyen::Client.new adyen.api_key = 'ADYEN_API_KEY' # For the LIVE environment, also include your liveEndpointUrlPrefix. adyen.env = :test # Set to "live" for live environment # Create the request object(s) request_body = { "amount" => { "currency" => "EUR", "value" => 1000 }, "reference" => "YOUR_ORDER_NUMBER", "shopperReference" => "YOUR_UNIQUE_SHOPPER_ID", "paymentMethod" => { "type" => "scheme", "encryptedCardNumber" => "adyenjs_0_1_18$k7s65M5V0KdPxTErhBIPoMPI8HlC..", "encryptedExpiryMonth" => "adyenjs_0_1_18$p2OZxW2XmwAA8C1Avxm3G9UB6e4..", "encryptedExpiryYear" => "adyenjs_0_1_18$CkCOLYZsdqpxGjrALWHj3QoGHqe+..", "encryptedSecurityCode" => "adyenjs_0_1_24$XUyMJyHebrra/TpSda9fha978+..", "holderName" => "S. Hopper" }, "authenticationData" => { "threeDSRequestData" => { }, "nativeThreeDS" => "preferred" } } # Send the request result = adyen.checkout.payments_api.payments(request_body, headers: { 'Idempotency-Key' => 'UUID' }) ``` #### NodeJS (TypeScript) ```ts // Adyen Node API Library v30.0.0 to latest import { Client, Config, EnvironmentEnum, CheckoutAPI, Types } from "@adyen/api-library"; // For the LIVE environment, also include your liveEndpointUrlPrefix. const config = new Config({ apiKey: "ADYEN_API_KEY", environment: EnvironmentEnum.TEST }); const client = new Client(config); // Create the request object(s) const threeDSRequestData: Types.checkout.ThreeDSRequestData = { }; const authenticationData: Types.checkout.AuthenticationData = { threeDSRequestData: threeDSRequestData }; const amount: Types.checkout.Amount = { currency: "EUR", value: 1000 }; const cardDetails: Types.checkout.CardDetails = { encryptedCardNumber: "adyenjs_0_1_18$k7s65M5V0KdPxTErhBIPoMPI8HlC..", holderName: "S. Hopper", encryptedSecurityCode: "adyenjs_0_1_24$XUyMJyHebrra/TpSda9fha978+..", encryptedExpiryYear: "adyenjs_0_1_18$CkCOLYZsdqpxGjrALWHj3QoGHqe+..", encryptedExpiryMonth: "adyenjs_0_1_18$p2OZxW2XmwAA8C1Avxm3G9UB6e4..", type: Types.checkout.CardDetails.TypeEnum.Scheme }; const paymentRequest = { reference: "YOUR_ORDER_NUMBER", authenticationData: authenticationData, amount: amount, paymentMethod: cardDetails, shopperReference: "YOUR_UNIQUE_SHOPPER_ID" } as unknown as Types.checkout.PaymentRequest; // Send the request const checkoutAPI = new CheckoutAPI(client); const response = await checkoutAPI.PaymentsApi.payments(paymentRequest, { idempotencyKey: "UUID" }); ``` 3. In the response, check if there is an `action` object. Your next steps depend on whether the response contains an `action` object, and on the `action.type`. | `action.type` | Description | Next steps | | ------------------ | ----------------------------------------------------------------------------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | | No `action` object | The transaction was either exempted or out-of-scope for 3D Secure 2 authentication. | Use the `resultCode` to [present the payment result to your shopper](https://docs.adyen.com/online-payments/3d-secure/native-3ds2#present-the-payment-result). | | **threeDS2** | The payment qualifies for 3D Secure 2, and will go through the authentication flow. | 1. Pass the `action` object to your front end to perform the authentication flow. 2. [Submit the challenge result](https://docs.adyen.com/online-payments/3d-secure/native-3ds2#submit-authentication-result). | | **redirect** | The payment is routed to the 3D Secure 2 redirect flow. | 1. Store `action.paymentData` on your server. 2. Pass the `action` object to your front end. 3. [Handle the redirect result](https://docs.adyen.com/online-payments/drop-in-web?tab=v67-actions_2#handle-the-redirect-result-1). | The following example shows a [/payments](https://docs.adyen.com/api-explorer/Checkout/67/post/payments) response with `action.type`: **threeDS2**. **/payments response with action** ```json { "action":{ "type":"threeDS2", "subtype": "fingerprint", "paymentData":"Ab02b4c0!BQABAgCuZFJrQOjSsl\/zt+...", "paymentMethodType":"scheme", "authorisationToken" : "Ab02b4c0!BQABAgAvrX03p...", "token":"eyJ0aHJlZURTTWV0aG9kTm90aWZpY..." }, "resultCode":"IdentifyShopper", ... } ``` ### Submit Authentication Result ## Submit the authentication result Drop-in handles the action after it is returned within the `onSubmit` event and performs the required authentication flow. If the issuer requires shopper interaction, Drop-in presents the challenge screen. **Pass the result code and action to Drop-in with onSubmit** ```javascript const checkout = await AdyenCheckout({ onSubmit: async (state, component, actions) => { // Make the /payments request and pass the action and resultCode back to Drop-in const { action, resultCode } = await makePayment(state.data); actions.resolve({ action, resultCode }); }, // ...Your other AdyenCheckout configurations. }); ``` When the shopper completes the challenge, Drop-in calls the [`onAdditionalDetails` ](https://docs.adyen.com/online-payments/build-your-integration/advanced-flow/?platform=Web\&integration=Drop-in\&version=latest#add)event. 1. Get the `state.data` from the `onAdditionalDetails` event, and pass it to your server. 2. From your server, make a POST [/payments/details](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments/details) request, specifying: * `details`: The `state.data.details` from the `onAdditionalDetails` event. **/payments/details request** ```bash curl https://checkout-test.adyen.com/v72/payments/details \ -H 'x-api-key: ADYEN_API_KEY' \ -H 'content-type: application/json' \ -d '{ ... "details": { "threeDSResult": "eyJ0cmFuc1N0YXR1cyI6IlkifQ==" } }' ``` The [/payments/details](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments/details) response has a `resultCode`. You will need it to [present the payment result](https://docs.adyen.com/online-payments/3d-secure/native-3ds2#present-the-payment-result). 3. Pass the `resultCode` you received in the [/payments/details](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments/details) response to the `actions.resolve()` object. Depending on the result code, the `onPaymentCompleted` or `onPaymentFailed` event is triggered to complete the payment flow. **Pass the result code to Drop-in with onAdditionalDetails** ```javascript const checkout = await AdyenCheckout({ onSubmit: async (state, component, actions) => {...} onAdditionalDetails: async (state, component, actions) => { // Make the /payments/details call and pass the resultCode back to the Drop-in. const { action, resultCode } = await makePaymentDetails(state.data); actions.resolve({ resultCode }); }, onPaymentCompleted(result, component) { // Handle the successful payment flow. }, onPaymentFailed(result, component) { // Handle the failed payment flow. }, // ... Your other AdyenCheckout configurations. }); ``` ### Present Result ## Present the payment result Use the  [resultCode](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments#responses-200-resultCode) from the [/payments](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments) or [/payments/details](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments/details) response to present the payment result to your shopper. You will also receive the outcome of the payment asynchronously in a [webhook](https://docs.adyen.com/development-resources/webhooks). For card payments, you can receive the following `resultCode` values: | resultCode | Description | Action to take | | -------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ | | **Authorised** | The payment was successful. | Inform the shopper that the payment has been successful. If you are using [manual capture](https://docs.adyen.com/online-payments/capture#manual-capture), you also need to [capture](https://docs.adyen.com/online-payments/capture) the payment. | | **Cancelled** | The shopper cancelled the payment. | Ask the shopper if they want to continue with the order, or ask them to select a different payment method. | | **Error** | There was an error when the payment was being processed. For more information, check the [`refusalReason` ](https://docs.adyen.com/development-resources/refusal-reasons)field. | Inform the shopper that there was an error processing their payment. | | **Refused** | The payment was refused. For more information, check the [`refusalReason` ](https://docs.adyen.com/development-resources/refusal-reasons)field. | Ask the shopper to try the payment again using a different payment method. | ### Testing ## Test and go live Use our test card numbers to [test how your integration handles different 3D Secure authentication scenarios](https://docs.adyen.com/development-resources/testing/3d-secure-2-authentication). When you are ready to [go live](https://docs.adyen.com/get-started-with-adyen/#apply-for-your-live-account), follow our [go-live checklist](https://docs.adyen.com/online-payments/go-live-checklist/). When using our [live endpoints](https://docs.adyen.com/development-resources/live-endpoints/), make sure that all API requests you make for the same payment session use the same live endpoint region. Using different regions for [/payments](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments) and [/payments/details](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments/details) requests may result in errors when authenticating with 3D Secure. ### Live environment values | Endpoint region | Value | | ------------------------- | ------------ | | Europe (EU) live | **live** | | United States (US) live | **live-us** | | Australia (AU) live | **live-au** | | Northeast Asia (NEA) live | **live-nea** | | India (IN) live | **live-in** | ## See also * [Web Drop-in integration guide](https://docs.adyen.com/online-payments/drop-in-web) * [3D Secure 2 API Reference](https://docs.adyen.com/online-payments/3d-secure/api-reference) * [3D Secure authentication](https://docs.adyen.com/online-payments/3d-secure) * [Webhooks](https://docs.adyen.com/development-resources/webhooks) ## Web Components Use the Component to support native 3D Secure 2 on your website ### Requirements This page explains how to implement native 3D Secure 2 authentication with your existing Web Components integration. ## Requirements Before you begin, take into account the following requirements, limitations, and preparations. | Requirement | Description | | -------------------------------------------------------------------- | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | | **Integration type** | Make sure you have an [Advanced flow Web Components integration](https://docs.adyen.com/online-payments/build-your-integration/advanced-flow/?platform=Web\&integration=Components) with the [Card Component](https://docs.adyen.com/payment-methods/cards/web-component). If you use the [Sessions flow](https://docs.adyen.com/online-payments/build-your-integration#sessions-flow-a-single-api-request), no additional configuration is needed to support 3D Secure 2. | | **[Webhooks](https://docs.adyen.com/development-resources/webhooks)** | Subscribe to Standard webhooks. | | **Limitations** | A strict [Content Security Policy (CSP)](https://developer.mozilla.org/en-US/docs/Web/HTTP/CSP) can prevent native 3D Secure 2 challenges from being loaded on your website, because loading the 3D Secure 2 interface requires adding more URLs to your CSP. Adyen does not maintain a list of all URLs. You can use the [redirect flow](https://docs.adyen.com/online-payments/3d-secure/redirect-3ds2/) if you do not want to adjust your CSP. | | **Setup steps** | Before you begin, [add the card payment methods that you want to accept in your test Customer Area](https://docs.adyen.com/payment-methods/add-payment-methods). | ## How it works To handle native 3D Secure 2 authentication: 1. [Get additional shopper details in your payment form](https://docs.adyen.com/online-payments/3d-secure/native-3ds2#get-additional-shopper-details). 2. [Make a payment request](https://docs.adyen.com/online-payments/3d-secure/native-3ds2#make-a-payment), including additional shopper details. 3. [Handle the 3D Secure 2 action](https://docs.adyen.com/online-payments/3d-secure/native-3ds2#handle-the-3d-secure-2-action) to perform the authentication flow. 4. [Submit the authentication result](https://docs.adyen.com/online-payments/3d-secure/native-3ds2#submit-authentication-result). 5. [Show the payment result](https://docs.adyen.com/online-payments/3d-secure/native-3ds2#show-the-payment-result). ### Collect Additional Details ## Collect additional shopper details in your payment form For higher authentication rates, we strongly recommend that you collect the shopper's email address, cardholder name, billing address, and IP address for payments with 3D Secure authentication. ### Tab: Use the Card Component Get the shopper's email outside of the Card Component because it does not have a configuration to include shopper email in the payment form. To get the cardholder name and billing address in your payment form, include the following when [creating an instance of the Card Component](https://docs.adyen.com/payment-methods/cards/web-component#step-2-create-an-instance-of-the-component). | Field | Description | Default | | ------------------------ | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ----------------------------- | | `hasHolderName` | Set to **true** to show the input field for the card holder name. | **false** | | `holderNameRequired` | Set to **true** to make the card holder name a required field. To show the field, you additionally need to set `hasHolderName` to **true**. | **false** | | `billingAddressRequired` | Set to **true** to collect the shopper's billing address. | **false** | | `challengeWindowSize` | The size of the challenge window displayed to the shopper in the [challenge flow](https://docs.adyen.com/online-payments/3d-secure#challenge-flow). Possible values: - **'01': \['250px', '400px']** - **'02': \['390px', '400px']** - **'03': \['500px', '600px']** - **'04': \['600px', '400px']** - **'05': \['100%', '100%']** | **'02': \['390px', '400px']** | Do not use placeholder data for these fields in your live environment. **Configure the card component** ```js const card = new Card(checkout, { hasHolderName: true, holderNameRequired: true, billingAddressRequired: true, challengeWindowSize: "05", // Your other card configurations. }).mount("#card-container"); ``` You can customize your shopper's experience further with optional [configuration parameters](https://docs.adyen.com/payment-methods/cards/web-component#optional-configuration) and specific [events](https://docs.adyen.com/payment-methods/cards/web-component#events). ### Tab: Build your own payment form Include these fields in your payment form: * Cardholder name * Billing address * Email address Send these parameters to your backend to include when [making a payment](https://docs.adyen.com/online-payments/3d-secure/native-3ds2#make-a-payment). Do not use placeholder data for these fields in your live environment. ## Make a payment 1. When you [make a payment request](https://docs.adyen.com/online-payments/build-your-integration/advanced-flow?platform=Web\&integration=Components\&version=latest#make-a-payment), include the following additional 3D Secure 2 parameters. See additional 3D Secure 2 parameters that we recommend to include in your request to increase authentication performance in our [API reference](https://docs.adyen.com/online-payments/3d-secure/api-reference). ### Tab: From the Card Component payment form | Parameter name | Required | Description | | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ | ------------------------------------------------------------------------------------------------------------------------------------------------------- | -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | | [paymentMethod](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments#request-paymentMethod) | ![Required](https://docs.adyen.com/media/732127089c689593ccb0331d565e5773bed94e60145cae96672212374facb8c6.svg?decoding=auto\&fetchpriority=auto) | The complete `state.data.paymentMethod` object from the `onSubmit` event. It includes the type and required details for a card payment method. | | [paymentMethod.sdkData](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments#request-paymentMethod-listOfValues-sdkData) | ![Required](https://docs.adyen.com/media/732127089c689593ccb0331d565e5773bed94e60145cae96672212374facb8c6.svg?decoding=auto\&fetchpriority=auto) | The object that includes the following information collected by the Component:- Information required for 3D Secure 2 authentication. - The [checkout attempt identifier](https://docs.adyen.com/online-payments/analytics-and-data-tracking#data-we-are-collecting) to track the user's payment journey. This is required to use the [Checkout dashboard](https://docs.adyen.com/uplift#uplift-dashboards) that lets you analyze your checkout performance. | | [paymentMethod.holderName](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments#request-paymentMethod-CardDetails-holderName) | ![Conditionally required](https://docs.adyen.com/media/e654d4104461d20836c817ee9d8f27faa0e45c1a8d08558f079561a50fc2797e.svg?decoding=auto\&fetchpriority=auto) | **Use case**: required for Visa and JCB transactions. The cardholder's name. | | [browserInfo](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments#request-browserInfo) | ![Required](https://docs.adyen.com/media/732127089c689593ccb0331d565e5773bed94e60145cae96672212374facb8c6.svg?decoding=auto\&fetchpriority=auto) | The shopper's browser information. All sub-fields of this object are required for `channel`: **Web**. This is the `state.data.browserInfo` object from the `onSubmit` event. | | [authenticationData.threeDSRequestData.nativeThreeDS](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments#request-authenticationData-threeDSRequestData-nativeThreeDS) **Checkout API v69 or later** | ![Required](https://docs.adyen.com/media/732127089c689593ccb0331d565e5773bed94e60145cae96672212374facb8c6.svg?decoding=auto\&fetchpriority=auto) | Set to **preferred**. Indicates if your payment page can handle native 3D Secure 2 authentication. For **Checkout API v68 or earlier**: use `additionalData.allow3DS2` instead. | | [channel](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments#request-channel) | ![Required](https://docs.adyen.com/media/732127089c689593ccb0331d565e5773bed94e60145cae96672212374facb8c6.svg?decoding=auto\&fetchpriority=auto) | The platform where the transaction takes place. Set to **Web**. | | [origin](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments#request-origin) | ![Required](https://docs.adyen.com/media/732127089c689593ccb0331d565e5773bed94e60145cae96672212374facb8c6.svg?decoding=auto\&fetchpriority=auto) | The origin URL of the page where you are rendering the Component. To get the origin, open the browser console and call `window.location.origin`. When this field is not set, or set incorrectly, the 3D Secure 2 action can not be handled correctly. **Format**:- Maximum characters: 80. - Do not include subdirectories and a trailing slash.**Example**: if you render the Component on `https://your-company.example.com/checkout/payment`, set to `https://your-company.example.com`. | | [returnUrl](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments#request-returnUrl) | ![Required](https://docs.adyen.com/media/732127089c689593ccb0331d565e5773bed94e60145cae96672212374facb8c6.svg?decoding=auto\&fetchpriority=auto) | The URL where the shopper is redirected back to after completing authentication, including the protocol `http://` or `https://`. For example, `https://your-company.example.com/checkout/`. You can also include your own additional query parameters, for example, shopper ID or order reference number. This is to support cases where the payment is routed to the redirect flow. | | [shopperEmail](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments#request-shopperEmail) | ![Conditionally required](https://docs.adyen.com/media/e654d4104461d20836c817ee9d8f27faa0e45c1a8d08558f079561a50fc2797e.svg?decoding=auto\&fetchpriority=auto) | **Use case**: required for Visa and JCB transactions. The cardholder's email address. If you do not include this, you must send the `telephoneNumber` or a phone number in the `threeDS2RequestData` object. | | [shopperIP](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments#request-shopperIP) | ![Conditionally required](https://docs.adyen.com/media/e654d4104461d20836c817ee9d8f27faa0e45c1a8d08558f079561a50fc2797e.svg?decoding=auto\&fetchpriority=auto) | **Use case**: required for Visa and JCB transactions on the web. The shopper's IP address. | | [telephoneNumber](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments#request-telephoneNumber) | ![Conditionally required](https://docs.adyen.com/media/e654d4104461d20836c817ee9d8f27faa0e45c1a8d08558f079561a50fc2797e.svg?decoding=auto\&fetchpriority=auto) | **Use case**: required for Visa and JCB transactions if you did not include the `shopperEmail` field. The shopper's phone number. To be more specific, you can use the `mobilePhone`, `homePhone`, and `workPhone` fields in the `threeDS2RequestData` object. **Format**: The phone number must include a plus sign (+) and a country code (1-3 digits), followed by the number (4-15 digits). **Example**: **+4912345678901**If the value you provide does not follow the guidelines, we drop the value and do not submit it for authentication. | ![This is the required icon.](https://docs.adyen.com/media/732127089c689593ccb0331d565e5773bed94e60145cae96672212374facb8c6.svg?decoding=auto\&fetchpriority=auto) Required for all transactions.\ ![This is the conditionally required icon.](https://docs.adyen.com/media/e654d4104461d20836c817ee9d8f27faa0e45c1a8d08558f079561a50fc2797e.svg?decoding=auto\&fetchpriority=auto) Required for particular setups, or issuers and card schemes.\ ![This is the recommended icon.](https://docs.adyen.com/media/51cfe94e37a7426974002173390b3c7807ac234e65206fe14ed9fbdd45fb958e.svg?decoding=auto\&fetchpriority=auto) Recommended for all transactions, but not required. ### Tab: From your own payment form | Parameter name | Required | Description | | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ | ------------------------------------------------------------------------------------------------------------------------------------------------------- | -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | | [paymentMethod.type](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments#request-paymentMethod-CardDetails-type) | ![Required](https://docs.adyen.com/media/732127089c689593ccb0331d565e5773bed94e60145cae96672212374facb8c6.svg?decoding=auto\&fetchpriority=auto) | Set to **scheme**. | | [paymentMethod.number](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments#request-paymentMethod-CardDetails-number) | ![Required](https://docs.adyen.com/media/732127089c689593ccb0331d565e5773bed94e60145cae96672212374facb8c6.svg?decoding=auto\&fetchpriority=auto) | The card number without separators. | | [paymentMethod.expiryMonth](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments#request-paymentMethod-CardDetails-expiryMonth) | ![Required](https://docs.adyen.com/media/732127089c689593ccb0331d565e5773bed94e60145cae96672212374facb8c6.svg?decoding=auto\&fetchpriority=auto) | The card expiry month | | [paymentMethod.expiryYear](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments#request-paymentMethod-CardDetails-expiryYear) | ![Required](https://docs.adyen.com/media/732127089c689593ccb0331d565e5773bed94e60145cae96672212374facb8c6.svg?decoding=auto\&fetchpriority=auto) | The card expiry year. | | [paymentMethod.cvc](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments#request-paymentMethod-CardDetails-cvc) | ![Required](https://docs.adyen.com/media/732127089c689593ccb0331d565e5773bed94e60145cae96672212374facb8c6.svg?decoding=auto\&fetchpriority=auto) | The card verification code. | | [paymentMethod.brand](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments#request-paymentMethod-CardDetails-brand) | ![Required](https://docs.adyen.com/media/732127089c689593ccb0331d565e5773bed94e60145cae96672212374facb8c6.svg?decoding=auto\&fetchpriority=auto) | The [brands](https://docs.adyen.com/payment-methods/cards/raw-card-data#co-badged) on the card. | | [paymentMethod.holderName](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments#request-paymentMethod-CardDetails-holderName) | ![Conditionally required](https://docs.adyen.com/media/e654d4104461d20836c817ee9d8f27faa0e45c1a8d08558f079561a50fc2797e.svg?decoding=auto\&fetchpriority=auto) | **Use case**: required for Visa and JCB transactions. The cardholder's name. | | [browserInfo](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments#request-browserInfo) | ![Required](https://docs.adyen.com/media/732127089c689593ccb0331d565e5773bed94e60145cae96672212374facb8c6.svg?decoding=auto\&fetchpriority=auto) | The shopper's browser information. All sub-fields of this object are required for `channel`: **Web**. This is the `state.data.browserInfo` object from the `onSubmit` event. | | [authenticationData.threeDSRequestData.nativeThreeDS](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments#request-authenticationData-threeDSRequestData-nativeThreeDS) **Checkout API v69 or later** | ![Required](https://docs.adyen.com/media/732127089c689593ccb0331d565e5773bed94e60145cae96672212374facb8c6.svg?decoding=auto\&fetchpriority=auto) | Set to **preferred**. Indicates if your payment page can handle native 3D Secure 2 authentication. For **Checkout API v68 or earlier**: use `additionalData.allow3DS2` instead. | | [channel](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments#request-channel) | ![Required](https://docs.adyen.com/media/732127089c689593ccb0331d565e5773bed94e60145cae96672212374facb8c6.svg?decoding=auto\&fetchpriority=auto) | The platform where the transaction takes place. Set to **Web**. | | [origin](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments#request-origin) | ![Required](https://docs.adyen.com/media/732127089c689593ccb0331d565e5773bed94e60145cae96672212374facb8c6.svg?decoding=auto\&fetchpriority=auto) | The origin URL of the page where you are rendering the Component. To get the origin, open the browser console and call `window.location.origin`. When this field is not set, or set incorrectly, the 3D Secure 2 action can not be handled correctly. **Format**:- Maximum characters: 80. - Do not include subdirectories and a trailing slash.**Example**: if you render the Component on `https://your-company.example.com/checkout/payment`, set to `https://your-company.example.com`. | | [returnUrl](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments#request-returnUrl) | ![Required](https://docs.adyen.com/media/732127089c689593ccb0331d565e5773bed94e60145cae96672212374facb8c6.svg?decoding=auto\&fetchpriority=auto) | The URL where the shopper is redirected back to after completing authentication, including the protocol `http://` or `https://`. For example, `https://your-company.example.com/checkout/`. You can also include your own additional query parameters, for example, shopper ID or order reference number. This is to support cases where the payment is routed to the redirect flow. | | [shopperEmail](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments#request-shopperEmail) | ![Conditionally required](https://docs.adyen.com/media/e654d4104461d20836c817ee9d8f27faa0e45c1a8d08558f079561a50fc2797e.svg?decoding=auto\&fetchpriority=auto) | **Use case**: required for Visa and JCB transactions. The cardholder's email address. If you do not include this, you must send a `telephoneNumber`, or a phone number in the `threeDS2RequestData` object. | | [shopperIP](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments#request-shopperIP) | ![Conditionally required](https://docs.adyen.com/media/e654d4104461d20836c817ee9d8f27faa0e45c1a8d08558f079561a50fc2797e.svg?decoding=auto\&fetchpriority=auto) | **Use cae**: required for Visa and JCB transactions on the web. The shopper's IP address. | | [telephoneNumber](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments#request-telephoneNumber) | ![Conditionally required](https://docs.adyen.com/media/e654d4104461d20836c817ee9d8f27faa0e45c1a8d08558f079561a50fc2797e.svg?decoding=auto\&fetchpriority=auto) | **Use case**: required for Visa and JCB transactions if you did not include the `shopperEmail` field. The shopper's phone number. To be more specific, you can use the `mobilePhone`, `homePhone`, and `workPhone` fields in the `threeDS2RequestData` object. **Format**: The phone number must include a plus sign (+) and a country code (1-3 digits), followed by the number (4-15 digits). **Example**: **+4912345678901**If the value you provide does not follow the guidelines, we drop the value and do not submit it for authentication. | ![This is the required icon.](https://docs.adyen.com/media/732127089c689593ccb0331d565e5773bed94e60145cae96672212374facb8c6.svg?decoding=auto\&fetchpriority=auto) Required for all transactions.\ ![This is the conditionally required icon.](https://docs.adyen.com/media/e654d4104461d20836c817ee9d8f27faa0e45c1a8d08558f079561a50fc2797e.svg?decoding=auto\&fetchpriority=auto) Required for particular setups, or issuers and card schemes.\ ![This is the recommended icon.](https://docs.adyen.com/media/51cfe94e37a7426974002173390b3c7807ac234e65206fe14ed9fbdd45fb958e.svg?decoding=auto\&fetchpriority=auto) Recommended for all transactions, but not required. Below is an example [/payments](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments) request for cases where you use your own payment form. #### curl ```bash curl https://checkout-test.adyen.com/v72/payments \ -H 'x-api-key: ADYEN_API_KEY' \ -H 'content-type: application/json' \ -d '{ "amount":{ "currency":"EUR", "value":1000 }, "reference":"YOUR_ORDER_NUMBER", "shopperReference":"YOUR_UNIQUE_SHOPPER_ID", "{hint:state.data.paymentMethod from onSubmit}paymentMethod{/hint}":{ "type":"scheme", "encryptedCardNumber":"adyenjs_0_1_18$k7s65M5V0KdPxTErhBIPoMPI8HlC..", "encryptedExpiryMonth":"adyenjs_0_1_18$p2OZxW2XmwAA8C1Avxm3G9UB6e4..", "encryptedExpiryYear":"adyenjs_0_1_18$CkCOLYZsdqpxGjrALWHj3QoGHqe+..", "encryptedSecurityCode":"adyenjs_0_1_24$XUyMJyHebrra/TpSda9fha978+..", "holderName":"S. Hopper" }, "authenticationData": { "threeDSRequestData": { "nativeThreeDS": "preferred" } }, "{hint:state.data.browserInfo from onSubmit}browserInfo{/hint}":{ "userAgent":"Mozilla\/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit\/537.36 (KHTML, like Gecko) Chrome\/70.0.3538.110 Safari\/537.36", "acceptHeader":"text\/html,application\/xhtml+xml,application\/xml;q=0.9,image\/webp,image\/apng,*\/*;q=0.8", "language":"nl-NL", "colorDepth":24, "screenHeight":723, "screenWidth":1536, "timeZoneOffset":0, "javaEnabled":true }, "{hint:state.data.billingAddress from onSubmit}billingAddress{/hint}": { "street": "Infinite Loop", "houseNumberOrName": "1", "postalCode": "1011DJ", "city": "Amsterdam", "country": "NL" }, "shopperEmail":"s.hopper@example.com", "shopperIP":"192.0.2.1", "channel":"web", "origin":"https://your-company.example.com", "returnUrl":"https://your-company.example.com/checkout?shopperOrder=12xy..", "merchantAccount":"YOUR_MERCHANT_ACCOUNT" }' ``` #### Java ```java // Adyen Java API Library v38.0.0 to latest import com.adyen.Client; import com.adyen.Config; import com.adyen.enums.Environment; import com.adyen.model.*; import com.adyen.service.*; import java.math.*; import com.adyen.model.checkout.*; import java.time.OffsetDateTime; import java.util.*; import com.adyen.model.RequestOptions; import com.adyen.service.checkout.*; Config config = new Config() .apiKey("ADYEN_API_KEY") .environment(Environment.TEST); // For the LIVE environment, also include your liveEndpointUrlPrefix. Client client = new Client(config); // Create the request object(s) ThreeDSRequestData threeDSRequestData = new ThreeDSRequestData(); AuthenticationData authenticationData = new AuthenticationData() .threeDSRequestData(threeDSRequestData); Amount amount = new Amount() .currency("EUR") .value(1000L); CardDetails cardDetails = new CardDetails() .encryptedCardNumber("adyenjs_0_1_18$k7s65M5V0KdPxTErhBIPoMPI8HlC..") .holderName("S. Hopper") .encryptedSecurityCode("adyenjs_0_1_24$XUyMJyHebrra/TpSda9fha978+..") .encryptedExpiryYear("adyenjs_0_1_18$CkCOLYZsdqpxGjrALWHj3QoGHqe+..") .encryptedExpiryMonth("adyenjs_0_1_18$p2OZxW2XmwAA8C1Avxm3G9UB6e4..") .type(CardDetails.TypeEnum.SCHEME); PaymentRequest paymentRequest = new PaymentRequest() .reference("YOUR_ORDER_NUMBER") .authenticationData(authenticationData) .amount(amount) .paymentMethod(new CheckoutPaymentMethod(cardDetails)) .shopperReference("YOUR_UNIQUE_SHOPPER_ID"); // Send the request PaymentsApi service = new PaymentsApi(client); PaymentResponse response = service.payments(paymentRequest, new RequestOptions().idempotencyKey("UUID")); ``` #### PHP ```php setXApiKey("ADYEN_API_KEY"); // For the LIVE environment, also include your liveEndpointUrlPrefix. $client->setEnvironment(Environment::TEST); // Create the request object(s) $threeDSRequestData = new ThreeDSRequestData(); $threeDSRequestData; $authenticationData = new AuthenticationData(); $authenticationData ->setThreeDSRequestData($threeDSRequestData); $amount = new Amount(); $amount ->setCurrency("EUR") ->setValue(1000); $checkoutPaymentMethod = new CheckoutPaymentMethod(); $checkoutPaymentMethod ->setEncryptedCardNumber("adyenjs_0_1_18\$k7s65M5V0KdPxTErhBIPoMPI8HlC..") ->setHolderName("S. Hopper") ->setEncryptedSecurityCode("adyenjs_0_1_24\$XUyMJyHebrra/TpSda9fha978+..") ->setEncryptedExpiryYear("adyenjs_0_1_18\$CkCOLYZsdqpxGjrALWHj3QoGHqe+..") ->setEncryptedExpiryMonth("adyenjs_0_1_18\$p2OZxW2XmwAA8C1Avxm3G9UB6e4..") ->setType("scheme"); $paymentRequest = new PaymentRequest(); $paymentRequest ->setReference("YOUR_ORDER_NUMBER") ->setAuthenticationData($authenticationData) ->setAmount($amount) ->setPaymentMethod($checkoutPaymentMethod) ->setShopperReference("YOUR_UNIQUE_SHOPPER_ID"); $requestOptions['idempotencyKey'] = 'UUID'; // Send the request $service = new PaymentsApi($client); $response = $service->payments($paymentRequest, $requestOptions); ``` #### C\# ```cs // Adyen .NET API Library v34.0.0 to latest using System; using Adyen.Checkout.Extensions; using Adyen.Checkout.Models; using Adyen.Checkout.Services; using Adyen.Core.Client; using Adyen.Core.Client.Extensions; using Adyen.Core.Options; using Microsoft.Extensions.DependencyInjection; using Microsoft.Extensions.Hosting; var host = Host.CreateDefaultBuilder() .ConfigureCheckout( (context, services, config) => { config.ConfigureAdyenOptions(options => { options.AdyenApiKey = "ADYEN_API_KEY"; options.Environment = AdyenEnvironment.Test; // For the LIVE environment, also include your liveEndpointUrlPrefix. // options.LiveEndpointUrlPrefix = ""; }); services.AddAllCheckoutServices(); }) .Build(); var paymentsService = host.Services.GetRequiredService(); // Create the request object(s) var threeDSRequestData = new ThreeDSRequestData { }; var authenticationData = new AuthenticationData { ThreeDSRequestData = threeDSRequestData }; var amount = new Amount { Currency = "EUR", Value = 1000 }; var cardDetails = new CardDetails { EncryptedCardNumber = "adyenjs_0_1_18$k7s65M5V0KdPxTErhBIPoMPI8HlC..", HolderName = "S. Hopper", EncryptedSecurityCode = "adyenjs_0_1_24$XUyMJyHebrra/TpSda9fha978+..", EncryptedExpiryYear = "adyenjs_0_1_18$CkCOLYZsdqpxGjrALWHj3QoGHqe+..", EncryptedExpiryMonth = "adyenjs_0_1_18$p2OZxW2XmwAA8C1Avxm3G9UB6e4..", Type = CardDetails.TypeEnum.Scheme }; var paymentRequest = new PaymentRequest { Reference = "YOUR_ORDER_NUMBER", AuthenticationData = authenticationData, Amount = amount, PaymentMethod = new CheckoutPaymentMethod(cardDetails), ShopperReference = "YOUR_UNIQUE_SHOPPER_ID" }; string idempotencyKey = Guid.NewGuid().ToString(); // Send the request var result = await paymentsService.PaymentsAsync(paymentRequest, new RequestOptions().AddIdempotencyKey(idempotencyKey)); if (result.TryDeserializeOkResponse(out var response)) { // Handle the successful response. } ``` #### NodeJS (JavaScript) ```js // Adyen Node API Library v30.0.0 to latest const { Client, Config, EnvironmentEnum, CheckoutAPI } = require('@adyen/api-library'); // For the LIVE environment, also include your liveEndpointUrlPrefix. const config = new Config({ apiKey: "ADYEN_API_KEY", environment: EnvironmentEnum.TEST }); const client = new Client(config); // Create the request object(s) const threeDSRequestData = { }; const authenticationData = { threeDSRequestData: threeDSRequestData }; const amount = { currency: "EUR", value: 1000 }; const cardDetails = { encryptedCardNumber: "adyenjs_0_1_18$k7s65M5V0KdPxTErhBIPoMPI8HlC..", holderName: "S. Hopper", encryptedSecurityCode: "adyenjs_0_1_24$XUyMJyHebrra/TpSda9fha978+..", encryptedExpiryYear: "adyenjs_0_1_18$CkCOLYZsdqpxGjrALWHj3QoGHqe+..", encryptedExpiryMonth: "adyenjs_0_1_18$p2OZxW2XmwAA8C1Avxm3G9UB6e4..", type: "scheme" }; const paymentRequest = { reference: "YOUR_ORDER_NUMBER", authenticationData: authenticationData, amount: amount, paymentMethod: cardDetails, shopperReference: "YOUR_UNIQUE_SHOPPER_ID" }; // Send the request const checkoutAPI = new CheckoutAPI(client); const response = await checkoutAPI.PaymentsApi.payments(paymentRequest, { idempotencyKey: "UUID" }); ``` #### Go ```go // Adyen Go API Library v21.0.0 to latest import ( "context" "github.com/adyen/adyen-go-api-library/v21/src/common" "github.com/adyen/adyen-go-api-library/v21/src/adyen" "github.com/adyen/adyen-go-api-library/v21/src/checkout" ) // For the LIVE environment, also include your liveEndpointUrlPrefix. client := adyen.NewClient(&common.Config{ ApiKey: "ADYEN_API_KEY", Environment: common.TestEnv, }) // Create the request object(s) threeDSRequestData := checkout.ThreeDSRequestData{ } authenticationData := checkout.AuthenticationData{ ThreeDSRequestData: &threeDSRequestData, } amount := checkout.Amount{ Currency: "EUR", Value: 1000, } cardDetails := checkout.CardDetails{ EncryptedCardNumber: common.PtrString("adyenjs_0_1_18$k7s65M5V0KdPxTErhBIPoMPI8HlC.."), HolderName: common.PtrString("S. Hopper"), EncryptedSecurityCode: common.PtrString("adyenjs_0_1_24$XUyMJyHebrra/TpSda9fha978+.."), EncryptedExpiryYear: common.PtrString("adyenjs_0_1_18$CkCOLYZsdqpxGjrALWHj3QoGHqe+.."), EncryptedExpiryMonth: common.PtrString("adyenjs_0_1_18$p2OZxW2XmwAA8C1Avxm3G9UB6e4.."), Type: common.PtrString("scheme"), } paymentRequest := checkout.PaymentRequest{ Reference: "YOUR_ORDER_NUMBER", AuthenticationData: &authenticationData, Amount: amount, PaymentMethod: checkout.CardDetailsAsCheckoutPaymentMethod(&cardDetails), ShopperReference: common.PtrString("YOUR_UNIQUE_SHOPPER_ID"), } // Send the request service := client.Checkout() req := service.PaymentsApi.PaymentsInput().IdempotencyKey("UUID").PaymentRequest(paymentRequest) res, httpRes, err := service.PaymentsApi.Payments(context.Background(), req) ``` #### Python ```py # Adyen Python API Library v14.0.0 to latest import Adyen adyen = Adyen.Adyen() adyen.client.xapikey = "ADYEN_API_KEY" # For the LIVE environment, also include your liveEndpointUrlPrefix. adyen.client.platform = "test" # The environment to use library in. # Create the request object(s) json_request = { "amount": { "currency": "EUR", "value": 1000 }, "reference": "YOUR_ORDER_NUMBER", "shopperReference": "YOUR_UNIQUE_SHOPPER_ID", "paymentMethod": { "type": "scheme", "encryptedCardNumber": "adyenjs_0_1_18$k7s65M5V0KdPxTErhBIPoMPI8HlC..", "encryptedExpiryMonth": "adyenjs_0_1_18$p2OZxW2XmwAA8C1Avxm3G9UB6e4..", "encryptedExpiryYear": "adyenjs_0_1_18$CkCOLYZsdqpxGjrALWHj3QoGHqe+..", "encryptedSecurityCode": "adyenjs_0_1_24$XUyMJyHebrra/TpSda9fha978+..", "holderName": "S. Hopper" }, "authenticationData": { "threeDSRequestData": { }, "nativeThreeDS": "preferred" } } # Send the request result = adyen.checkout.payments_api.payments(request=json_request, idempotency_key="UUID") ``` #### Ruby ```rb # Adyen Ruby API Library v11.0.0 to latest require "adyen-ruby-api-library" adyen = Adyen::Client.new adyen.api_key = 'ADYEN_API_KEY' # For the LIVE environment, also include your liveEndpointUrlPrefix. adyen.env = :test # Set to "live" for live environment # Create the request object(s) request_body = { "amount" => { "currency" => "EUR", "value" => 1000 }, "reference" => "YOUR_ORDER_NUMBER", "shopperReference" => "YOUR_UNIQUE_SHOPPER_ID", "paymentMethod" => { "type" => "scheme", "encryptedCardNumber" => "adyenjs_0_1_18$k7s65M5V0KdPxTErhBIPoMPI8HlC..", "encryptedExpiryMonth" => "adyenjs_0_1_18$p2OZxW2XmwAA8C1Avxm3G9UB6e4..", "encryptedExpiryYear" => "adyenjs_0_1_18$CkCOLYZsdqpxGjrALWHj3QoGHqe+..", "encryptedSecurityCode" => "adyenjs_0_1_24$XUyMJyHebrra/TpSda9fha978+..", "holderName" => "S. Hopper" }, "authenticationData" => { "threeDSRequestData" => { }, "nativeThreeDS" => "preferred" } } # Send the request result = adyen.checkout.payments_api.payments(request_body, headers: { 'Idempotency-Key' => 'UUID' }) ``` #### NodeJS (TypeScript) ```ts // Adyen Node API Library v30.0.0 to latest import { Client, Config, EnvironmentEnum, CheckoutAPI, Types } from "@adyen/api-library"; // For the LIVE environment, also include your liveEndpointUrlPrefix. const config = new Config({ apiKey: "ADYEN_API_KEY", environment: EnvironmentEnum.TEST }); const client = new Client(config); // Create the request object(s) const threeDSRequestData: Types.checkout.ThreeDSRequestData = { }; const authenticationData: Types.checkout.AuthenticationData = { threeDSRequestData: threeDSRequestData }; const amount: Types.checkout.Amount = { currency: "EUR", value: 1000 }; const cardDetails: Types.checkout.CardDetails = { encryptedCardNumber: "adyenjs_0_1_18$k7s65M5V0KdPxTErhBIPoMPI8HlC..", holderName: "S. Hopper", encryptedSecurityCode: "adyenjs_0_1_24$XUyMJyHebrra/TpSda9fha978+..", encryptedExpiryYear: "adyenjs_0_1_18$CkCOLYZsdqpxGjrALWHj3QoGHqe+..", encryptedExpiryMonth: "adyenjs_0_1_18$p2OZxW2XmwAA8C1Avxm3G9UB6e4..", type: Types.checkout.CardDetails.TypeEnum.Scheme }; const paymentRequest = { reference: "YOUR_ORDER_NUMBER", authenticationData: authenticationData, amount: amount, paymentMethod: cardDetails, shopperReference: "YOUR_UNIQUE_SHOPPER_ID" } as unknown as Types.checkout.PaymentRequest; // Send the request const checkoutAPI = new CheckoutAPI(client); const response = await checkoutAPI.PaymentsApi.payments(paymentRequest, { idempotencyKey: "UUID" }); ``` 2. In the response, check if there is an `action` object. Your next steps depend on whether the response contains an `action` object, and on the `action.type`. | `action.type` | Description | Next steps | | ------------------ | ----------------------------------------------------------------------------------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | | No `action` object | The transaction was either exempted or out-of-scope for 3D Secure 2 authentication. | Use the `resultCode` to [show the payment result to your shopper](https://docs.adyen.com/online-payments/3d-secure/native-3ds2#show-the-payment-result). | | **threeDS2** | The payment qualifies for 3D Secure 2, and will go through the authentication flow. | 1. Pass the `action` object to your front end. 2. [Use the Component](https://docs.adyen.com/online-payments/3d-secure/native-3ds2#handle-the-3d-secure-2-action) to perform the authentication flow. 3. [Submit the authentication result](https://docs.adyen.com/online-payments/3d-secure/native-3ds2#submit-authentication-result). | | **redirect** | The payment is routed to the 3D Secure 2 redirect flow. | 1. Pass the `action` object to your front end. 2. [Use `handleAction`](https://docs.adyen.com/online-payments/build-your-integration/advanced-flow/?platform=Web\&integration=Components\&version=6.3.0#additional-action) to handle the redirect. 3. [Confirm the redirect result](https://docs.adyen.com/online-payments/build-your-integration/advanced-flow/?platform=Web\&integration=Components\&version=6.3.0#send-additional-payment-details). | The following example shows a [/payments](https://docs.adyen.com/api-explorer/Checkout/67/post/payments) response with `action.type`: **threeDS2**. **/payments response with action** ```json { "action":{ "type":"threeDS2", "subtype": "fingerprint", "paymentData":"Ab02b4c0!BQABAgCuZFJrQOjSsl\/zt+...", "paymentMethodType":"scheme", "authorisationToken" : "Ab02b4c0!BQABAgAvrX03p...", "token":"eyJ0aHJlZURTTWV0aG9kTm90aWZpY..." }, "resultCode":"IdentifyShopper", ... } ``` ### Handle The Action ## Handle the 3D Secure 2 action If your integration uses the Card Component to collect the shopper's card details, also use it to handle the 3D Secure 2 action on the same page. If you built your own UI for collecting the shopper's card details or want to render 3D Secure authentication on a different page than the payment, create a new 3D Secure 2 Component. ### Tab: Use the Card Component The Component handles the 3D secure 2 action after it is returned within the `onSubmit` event and performs the required authentication flow. If the issuer requires shopper interaction, the Component presents the challenge screen, and calls the `onAdditionalDetails` event. **Configure AdyenCheckout** ```javascript const checkout = await AdyenCheckout({ onSubmit: async (state, component, actions) => { // Make the /payments request and pass the action and resultCode back to Drop-in const { action, resultCode } = await makePayment(state.data); actions.resolve({ action, resultCode }); }, onAdditionalDetails: async (state, component, actions) => { // Make the /payments/details call and pass the resultCode back to the Component. const { action, resultCode } = await makePaymentDetails(state.data); actions.resolve({ resultCode }); }, onPaymentCompleted(result, component) { // Handle the successful payment flow. }, onPaymentFailed(result, component) { // Handle the failed payment flow. }, // ... Your other AdyenCheckout configurations. }); ``` ### Tab: Create a new 3D Secure 2 Component To create the Component and handle the action: 1. [Get Adyen Web](https://docs.adyen.com/online-payments/build-your-integration/sessions-flow?platform=Web\&integration=Components#get-adyen-web). 2. []()Create an instance of `AdyenCheckout`, specifying the following parameters: | Parameter | Description | | --------------------- | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | | `environment` | When you are ready to accept live payments, change the value to match your [live endpoints](https://docs.adyen.com/development-resources/live-endpoints): - Europe: **live** - Australia: **live-au** - US: **live-us** - Northeast Asia: **live-nea** - India: **live-in** | | `countryCode` | The shopper's country code. | | `onAdditionalDetails` | Implement a function that the Component calls after presenting the challenge window. Make a POST [/payments/details](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments/details) request. Then, call the `actions.resolve()` object, passing the `resultCode`, and `action` from the API response. | **Configure AdyenCheckout** ```javascript const checkout = await AdyenCheckout({ clientKey: "YOUR_CLIENT_KEY", environment: 'test', locale: 'nl-NL', countryCode: 'NL', onAdditionalDetails: async (state, component, actions) => { // Make the /payments/details call and pass the resultCode back to the Component. const { action, resultCode } = await makePaymentDetails(state.data); actions.resolve({ resultCode }); }, onPaymentCompleted(result, component) { // Handle the successful payment flow. }, onPaymentFailed(result, component) { // Handle the failed payment flow. }, // ... Your other AdyenCheckout configurations. }); ``` 3. []()Call `createFromAction`, passing the `action` object from the [/payments](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments) response and optional configuration. This returns a new Component. 4. Mount the Component: ```js // Pass the action object from the /payments response. // Add optional configuration. For example, the window size. // Mount the Component to your container. checkout.createFromAction(action, { challengeWindowSize: '02' }).mount('#my-container'); ``` The Component performs the authentication flow and calls the `onAdditionalDetails` event. ### Handle Component errors When an error occurs, [the `onError` event](https://docs.adyen.com/online-payments/build-your-integration/sessions-flow/?platform=Web\&integration=Components\&version=latest#configure) returns an object which contains details about the error. For errors that happen during the 3D Secure 2 authentication, you do not need to stop the payment flow because the shopper can continue. ### Submit Authentication Result ## Submit the authentication result 1. Get the `state.data` from the `onAdditionalDetails` event, and pass it your server. 2. From your server, make a POST [/payments/details](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments/details) request, specifying: * `details`: The `state.data.details` from the `onAdditionalDetails` event. **/payments/details request** #### curl ```bash curl https://checkout-test.adyen.com/v72/payments/details \ -H 'x-api-key: ADYEN_API_KEY' \ -H 'content-type: application/json' \ -d '{ "details": { "threeDSResult": "eyJ0cmFuc1N0YXR1cyI6IlkifQ==" } }' ``` #### Java ```java // Adyen Java API Library v38.0.0 to latest import com.adyen.Client; import com.adyen.Config; import com.adyen.enums.Environment; import com.adyen.model.*; import com.adyen.service.*; import java.math.*; import com.adyen.model.checkout.*; import java.time.OffsetDateTime; import java.util.*; import com.adyen.model.RequestOptions; import com.adyen.service.checkout.*; Config config = new Config() .apiKey("ADYEN_API_KEY") .environment(Environment.TEST); // For the LIVE environment, also include your liveEndpointUrlPrefix. Client client = new Client(config); // Create the request object(s) PaymentCompletionDetails paymentCompletionDetails = new PaymentCompletionDetails() .threeDSResult("eyJ0cmFuc1N0YXR1cyI6IlkifQ=="); PaymentDetailsRequest paymentDetailsRequest = new PaymentDetailsRequest() .details(paymentCompletionDetails); // Send the request PaymentsApi service = new PaymentsApi(client); PaymentDetailsResponse response = service.paymentsDetails(paymentDetailsRequest, new RequestOptions().idempotencyKey("UUID")); ``` #### PHP ```php setXApiKey("ADYEN_API_KEY"); // For the LIVE environment, also include your liveEndpointUrlPrefix. $client->setEnvironment(Environment::TEST); // Create the request object(s) $paymentCompletionDetails = new PaymentCompletionDetails(); $paymentCompletionDetails ->setThreeDSResult("eyJ0cmFuc1N0YXR1cyI6IlkifQ=="); $paymentDetailsRequest = new PaymentDetailsRequest(); $paymentDetailsRequest ->setDetails($paymentCompletionDetails); $requestOptions['idempotencyKey'] = 'UUID'; // Send the request $service = new PaymentsApi($client); $response = $service->paymentsDetails($paymentDetailsRequest, $requestOptions); ``` #### C\# ```cs // Adyen .NET API Library v34.0.0 to latest using System; using Adyen.Checkout.Extensions; using Adyen.Checkout.Models; using Adyen.Checkout.Services; using Adyen.Core.Client; using Adyen.Core.Client.Extensions; using Adyen.Core.Options; using Microsoft.Extensions.DependencyInjection; using Microsoft.Extensions.Hosting; var host = Host.CreateDefaultBuilder() .ConfigureCheckout( (context, services, config) => { config.ConfigureAdyenOptions(options => { options.AdyenApiKey = "ADYEN_API_KEY"; options.Environment = AdyenEnvironment.Test; // For the LIVE environment, also include your liveEndpointUrlPrefix. // options.LiveEndpointUrlPrefix = ""; }); services.AddAllCheckoutServices(); }) .Build(); var paymentsService = host.Services.GetRequiredService(); // Create the request object(s) var paymentCompletionDetails = new PaymentCompletionDetails { ThreeDSResult = "eyJ0cmFuc1N0YXR1cyI6IlkifQ==" }; var paymentDetailsRequest = new PaymentDetailsRequest { Details = paymentCompletionDetails }; string idempotencyKey = Guid.NewGuid().ToString(); // Send the request var result = await paymentsService.PaymentsDetailsAsync(paymentDetailsRequest, new RequestOptions().AddIdempotencyKey(idempotencyKey)); if (result.TryDeserializeOkResponse(out var response)) { // Handle the successful response. } ``` #### NodeJS (JavaScript) ```js // Adyen Node API Library v30.0.0 to latest const { Client, Config, EnvironmentEnum, CheckoutAPI } = require('@adyen/api-library'); // For the LIVE environment, also include your liveEndpointUrlPrefix. const config = new Config({ apiKey: "ADYEN_API_KEY", environment: EnvironmentEnum.TEST }); const client = new Client(config); // Create the request object(s) const paymentCompletionDetails = { threeDSResult: "eyJ0cmFuc1N0YXR1cyI6IlkifQ==" }; const paymentDetailsRequest = { details: paymentCompletionDetails }; // Send the request const checkoutAPI = new CheckoutAPI(client); const response = await checkoutAPI.PaymentsApi.paymentsDetails(paymentDetailsRequest, { idempotencyKey: "UUID" }); ``` #### Go ```go // Adyen Go API Library v21.0.0 to latest import ( "context" "github.com/adyen/adyen-go-api-library/v21/src/common" "github.com/adyen/adyen-go-api-library/v21/src/adyen" "github.com/adyen/adyen-go-api-library/v21/src/checkout" ) // For the LIVE environment, also include your liveEndpointUrlPrefix. client := adyen.NewClient(&common.Config{ ApiKey: "ADYEN_API_KEY", Environment: common.TestEnv, }) // Create the request object(s) paymentCompletionDetails := checkout.PaymentCompletionDetails{ ThreeDSResult: common.PtrString("eyJ0cmFuc1N0YXR1cyI6IlkifQ=="), } paymentDetailsRequest := checkout.PaymentDetailsRequest{ Details: paymentCompletionDetails, } // Send the request service := client.Checkout() req := service.PaymentsApi.PaymentsDetailsInput().IdempotencyKey("UUID").PaymentDetailsRequest(paymentDetailsRequest) res, httpRes, err := service.PaymentsApi.PaymentsDetails(context.Background(), req) ``` #### Python ```py # Adyen Python API Library v14.0.0 to latest import Adyen adyen = Adyen.Adyen() adyen.client.xapikey = "ADYEN_API_KEY" # For the LIVE environment, also include your liveEndpointUrlPrefix. adyen.client.platform = "test" # The environment to use library in. # Create the request object(s) json_request = { "details": { "threeDSResult": "eyJ0cmFuc1N0YXR1cyI6IlkifQ==" } } # Send the request result = adyen.checkout.payments_api.payments_details(request=json_request, idempotency_key="UUID") ``` #### Ruby ```rb # Adyen Ruby API Library v11.0.0 to latest require "adyen-ruby-api-library" adyen = Adyen::Client.new adyen.api_key = 'ADYEN_API_KEY' # For the LIVE environment, also include your liveEndpointUrlPrefix. adyen.env = :test # Set to "live" for live environment # Create the request object(s) request_body = { "details" => { "threeDSResult" => "eyJ0cmFuc1N0YXR1cyI6IlkifQ==" } } # Send the request result = adyen.checkout.payments_api.payments_details(request_body, headers: { 'Idempotency-Key' => 'UUID' }) ``` #### NodeJS (TypeScript) ```ts // Adyen Node API Library v30.0.0 to latest import { Client, Config, EnvironmentEnum, CheckoutAPI, Types } from "@adyen/api-library"; // For the LIVE environment, also include your liveEndpointUrlPrefix. const config = new Config({ apiKey: "ADYEN_API_KEY", environment: EnvironmentEnum.TEST }); const client = new Client(config); // Create the request object(s) const paymentCompletionDetails: Types.checkout.PaymentCompletionDetails = { threeDSResult: "eyJ0cmFuc1N0YXR1cyI6IlkifQ==" }; const paymentDetailsRequest: Types.checkout.PaymentDetailsRequest = { details: paymentCompletionDetails }; // Send the request const checkoutAPI = new CheckoutAPI(client); const response = await checkoutAPI.PaymentsApi.paymentsDetails(paymentDetailsRequest, { idempotencyKey: "UUID" }); ``` The [/payments/details](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments/details) response has a `resultCode`. You need it to [show the payment result](https://docs.adyen.com/online-payments/3d-secure/native-3ds2#show-the-payment-result). 3. Pass the `resultCode` you received in the [/payments/details](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments/details) to the `actions.resolve()` object in the `onAdditionalDetails` event. 4. Depending on the `resultCode`, handle the payment flow with the `onPaymentCompleted` or `onPaymentFailed` event. ### Present Result ## Present the payment result Use the  [resultCode](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments#responses-200-resultCode) from the [/payments](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments) or [/payments/details](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments/details) response to present the payment result to your shopper. You will also receive the outcome of the payment asynchronously in a [webhook](https://docs.adyen.com/development-resources/webhooks). For card payments, you can receive the following `resultCode` values: | resultCode | Description | Action to take | | -------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ | | **Authorised** | The payment was successful. | Inform the shopper that the payment has been successful. If you are using [manual capture](https://docs.adyen.com/online-payments/capture#manual-capture), you also need to [capture](https://docs.adyen.com/online-payments/capture) the payment. | | **Cancelled** | The shopper cancelled the payment. | Ask the shopper if they want to continue with the order, or ask them to select a different payment method. | | **Error** | There was an error when the payment was being processed. For more information, check the [`refusalReason` ](https://docs.adyen.com/development-resources/refusal-reasons)field. | Inform the shopper that there was an error processing their payment. | | **Refused** | The payment was refused. For more information, check the [`refusalReason` ](https://docs.adyen.com/development-resources/refusal-reasons)field. | Ask the shopper to try the payment again using a different payment method. | ### Testing ## Test and go live Use our test card numbers to [test how your integration handles different 3D Secure authentication scenarios](https://docs.adyen.com/development-resources/testing/3d-secure-2-authentication). When you are ready to [go live](https://docs.adyen.com/get-started-with-adyen/#apply-for-your-live-account), follow our [go-live checklist](https://docs.adyen.com/online-payments/go-live-checklist/). When using our [live endpoints](https://docs.adyen.com/development-resources/live-endpoints/), make sure that all API requests you make for the same payment session use the same live endpoint region. Using different regions for [/payments](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments) and [/payments/details](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments/details) requests may result in errors when authenticating with 3D Secure. ### Live environment values | Endpoint region | Value | | ------------------------- | ------------ | | Europe (EU) live | **live** | | United States (US) live | **live-us** | | Australia (AU) live | **live-au** | | Northeast Asia (NEA) live | **live-nea** | | India (IN) live | **live-in** | ## See also * [Web Components integration guide](https://docs.adyen.com/online-payments/components-web) * [3D Secure 2 API Reference](https://docs.adyen.com/online-payments/3d-secure/api-reference) * [3D Secure authentication](https://docs.adyen.com/online-payments/3d-secure) * [Webhooks](https://docs.adyen.com/development-resources/webhooks) ## iOS Drop-in Use Drop-in to support native 3D Secure 2 with your iOS app ### Requirements This page explains how to implement native 3D Secure 2 authentication with your existing iOS Drop-in integration. ## Requirements Before you begin, take into account the following requirements, limitations, and preparations. | Requirement | Description | | -------------------------------------------------------------------- | -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | | **Integration type** | Make sure you have an [Advanced flow iOS Drop-in integration](https://docs.adyen.com/online-payments/build-your-integration/advanced-flow/?platform=iOS\&integration=Drop-in). If you use the [Sessions flow](https://docs.adyen.com/online-payments/build-your-integration#sessions-flow-a-single-api-request), no additional configuration is needed to support 3D Secure 2. | | **[Webhooks](https://docs.adyen.com/development-resources/webhooks)** | Subscribe to Standard webhooks. | | **Setup steps** | Before you begin:- [Add the card payment methods that you want to accept in your test Customer Area](https://docs.adyen.com/payment-methods/add-payment-methods). - Make sure that your back end can [handle redirects](https://docs.adyen.com/online-payments/build-your-integration/advanced-flow/?platform=iOS\&integration=Components\&version=latest#redirect-component) for cases where the payment is routed to the [Redirect 3D Secure 2 flow](https://docs.adyen.com/online-payments/3d-secure/redirect-3ds2/ios-drop-in). | ## How it works Our [iOS Drop-in](https://docs.adyen.com/online-payments/build-your-integration/sessions-flow?platform=iOS\&integration=Drop-in) renders the available cards in your payment form, and securely collects any sensitive card information, so it doesn't touch your server. Drop-in also handles the 3D Secure 2 device fingerprinting and challenge flows, including the data exchange between your front end and the issuer's Access Control Server (ACS). When making a card payment with native 3D Secure 2 authentication, you need to: 1. [Configure Drop-in](https://docs.adyen.com/online-payments/3d-secure/native-3ds2#configure-drop-in) to collect the cardholder name. 2. Provide additional parameters [when making a payment request](https://docs.adyen.com/online-payments/3d-secure/native-3ds2#make-a-payment). 3. [Submit the authentication result](https://docs.adyen.com/online-payments/3d-secure/native-3ds2#submit-authentication-results) if you receive an `action` object in response to your [/payments](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments) or [/payments/details](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments/details) request. 4. In some cases, the payment may be routed to the redirect flow, when this happens, [handle the redirect](https://docs.adyen.com/online-payments/build-your-integration/sessions-flow?platform=iOS\&integration=Drop-in#handle-the-redirect). ### Collect Additional Parameters ## Collect additional information at checkout For higher authentication rates, we strongly recommend that you collect the shopper cardholder name and billing address in advance in your payment form. Deliver these parameters to your backend when [making a payment](https://docs.adyen.com/online-payments/3d-secure/native-3ds2#make-a-payment), because they are required by the card schemes. ### Show Available Cards ## Show the available cards in your payment form For information about the supported countries/regions and currencies for each card, refer to [Payment methods](https://www.adyen.com/payment-methods). To show cards in your payment form: 1. Specify in your [/paymentMethods](https://docs.adyen.com/api-explorer/Checkout/latest/post/paymentMethods) request a combination of [countryCode](https://docs.adyen.com/api-explorer/Checkout/latest/post/paymentMethods) and [amount.currency](https://docs.adyen.com/api-explorer/Checkout/latest/post/paymentMethods#request-amount). Drop-in uses this information to show the available cards to your shopper. 2. []()When [initializing the Drop-in](https://docs.adyen.com/online-payments/build-your-integration/sessions-flow/?platform=iOS\&integration=Drop-in#step-3-set-up-drop-in), create a configuration object, and specify: * `configuration.card.showsHolderNameField`: **true**. This shows the input field for the cardholder name. 3. If you want to set `threeDSRequestorAppURL`, create a configuration object and specify `actionComponent.threeDS.requestorAppURL`. Always use a universal link. ```swift let configuration = DropInComponent.Configuration(apiContext: apiContext) configuration.card.showsHolderNameField = true // Shows the field for entering the holder name. configuration.actionComponent.threeDS.requestorAppURL = URL(string: "YOUR_APP_URL") // Optional, add a universal link here when you want to send threeDSRequestorAppURL. ``` When the shopper is entering their card details, Drop-in tries to recognize the card brand. When successful, Drop-in renders the brand icon. ## Make a payment When the shopper proceeds to pay, Drop-in invokes the `didSubmit` method which contains `data.paymentMethod`. 1. Pass `data.paymentMethod` to your server.\ When you [make a payment request](https://docs.adyen.com/online-payments/build-your-integration/advanced-flow?platform=iOS\&integration=Drop-in\&version=latest#make-a-payment), include the following additional 3D Secure 2 parameters. See additional 3D Secure 2 parameters that we recommend to include in your request to increase authentication performance in our [API reference](https://docs.adyen.com/online-payments/3d-secure/api-reference). | Parameter name | Required | Description | | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ | ------------------------------------------------------------------------------------------------------------------------------------------------------- | -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | | [paymentMethod](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments#request-paymentMethod) | ![Required](https://docs.adyen.com/media/732127089c689593ccb0331d565e5773bed94e60145cae96672212374facb8c6.svg?decoding=auto\&fetchpriority=auto) | The complete `data.paymentMethod` object from the `didSubmit` event from your client app. It includes the type and required details for a card payment method. | | [paymentMethod.sdkData](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments#request-paymentMethod-listOfValues-sdkData) | ![Required](https://docs.adyen.com/media/732127089c689593ccb0331d565e5773bed94e60145cae96672212374facb8c6.svg?decoding=auto\&fetchpriority=auto) | The object that includes the following information collected by Drop-in:- Information required for 3D Secure 2 authentication. - The [checkout attempt identifier](https://docs.adyen.com/online-payments/analytics-and-data-tracking#data-we-are-collecting) to track the user's payment journey. This is required to use the [Checkout dashboard](https://docs.adyen.com/uplift#uplift-dashboards) that lets you analyze your checkout performance. | | [paymentMethod.holderName](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments#request-paymentMethod-CardDetails-holderName) | ![Conditionally required](https://docs.adyen.com/media/e654d4104461d20836c817ee9d8f27faa0e45c1a8d08558f079561a50fc2797e.svg?decoding=auto\&fetchpriority=auto) | **Use case**: required for Visa and JCB transactions. The cardholder's name. | | [authenticationData.threeDSRequestData.nativeThreeDS](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments#request-authenticationData-threeDSRequestData-nativeThreeDS) **Checkout API v69 or later** | ![Required](https://docs.adyen.com/media/732127089c689593ccb0331d565e5773bed94e60145cae96672212374facb8c6.svg?decoding=auto\&fetchpriority=auto) | Set to **preferred**. Indicates if your payment page can handle native 3D Secure 2 authentication. For **Checkout API v68 or earlier**: use `additionalData.allow3DS2` instead. | | [channel](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments#request-channel) | ![Required](https://docs.adyen.com/media/732127089c689593ccb0331d565e5773bed94e60145cae96672212374facb8c6.svg?decoding=auto\&fetchpriority=auto) | The platform where the transaction takes place. Set to **iOS**. | | [returnUrl](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments#request-returnUrl) | ![Required](https://docs.adyen.com/media/732127089c689593ccb0331d565e5773bed94e60145cae96672212374facb8c6.svg?decoding=auto\&fetchpriority=auto) | Used to redirect the shopper back to a webpage for redirect and other payment flows. If you want to redirect the shopper to your app, [configure a `threeDSRequestorAppURL`](https://docs.adyen.com/online-payments/3d-secure/native-3ds2#show-cards). | | [shopperEmail](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments#request-shopperEmail) |
[...]
